import sys
import urllib
import urllib2
import json

sys.path.append("scripts")
from process import send_to_mv

def link_code(address, username, objects):
    data = []

    data.append(("V", '3'))
    data.append(("V", '"link_and_load"'))
    for obj in objects:
        data.append(("V", '"%s"' % obj))
    data.append(("V", '""'))

    # Call the main function
    data.append(("V", '"main"'))
    return data

def link(address, username, objects):
    # Read out all symbol tables that are to be linked
    send_to_mv(address, username, link_code(address, username, objects))

    v = urllib2.urlopen(urllib2.Request(address, urllib.urlencode({"op": "get_output", "username": username}))).read()
    if "OK" not in v:
        print(v)
        raise Exception("Linking error")

if __name__ == "__main__":
    if len(sys.argv) == 1:
        print("No username defined")
    else:
        address = sys.argv[1]
        username = sys.argv[2]
        objects = set(sys.argv[3:])

        if objects:
            link(address, username, objects)
        else:
            print("No files to link defined")
